package lcsb.mapviewer.persist.dao;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import lcsb.mapviewer.model.user.Configuration;
import lcsb.mapviewer.model.user.ConfigurationElementType;
import lcsb.mapviewer.persist.PersistTestFunctions;

public class ConfigurationDaoTest extends PersistTestFunctions {
	@Autowired
	protected ConfigurationDao configurationDao;

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testGetNull() {
		assertNull(configurationDao.getByType(null));
	}

	@Test
	public void testGetValueByType() {
		// check data for null input (failsafe test)
		assertNull(configurationDao.getValueByType(null));

		// check data for somethig that is in database
		String val = configurationDao.getValueByType(ConfigurationElementType.LOGO_TEXT);
		assertNotNull(val);

		// remove data from database
		Configuration obj = configurationDao.getByType(ConfigurationElementType.LOGO_TEXT);
		configurationDao.delete(obj);

		// and now check data for somethig that is not in database
		assertNotNull(configurationDao.getValueByType(ConfigurationElementType.LOGO_TEXT));

	}

}
